#####
###  MailBoxer - a mailinglist/newsletter/mailarchive-framework for ZOPE
##   Copyright (C) 2003	Maik Jablonski (maik.jablonski@uni-bielefeld.de)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#####

MailBoxerTemplates={}

MailBoxerTemplates['mail_header'] = r"""
<dtml-comment>
These are additional headers for mailinglists which will be added to the bulked
mails. Don't delete the X-Mailer. It's important to avoid endless mail-loops.
</dtml-comment>

Content-type: <dtml-var "mail.get('content-type','text/plain')">
Subject: <dtml-if "mime_decode_header(mail.get('subject','')).find('['+title+']')==-1">[<dtml-var title>] </dtml-if><dtml-var "mail.get('subject','No Subject')">
X-Mailer: <dtml-var xmailer>
Precedence: Bulk
Reply-To: <dtml-var mailto>
Errors-To: <dtml-var "moderator[0]">
List-Post: <mailto:<dtml-var mailto>>
List-Subscribe: <mailto:<dtml-var mailto>?subject=subscribe>
List-Unsubscribe: <mailto:<dtml-var mailto>?subject=unsubscribe>
List-Id: <dtml-var title>
List-Archive: <<dtml-var URL1>>
"""

MailBoxerTemplates['mail_footer'] = r"""
<dtml-comment>
This is a additional footer for plain-text-mails which will be added to the bulked
mails.
</dtml-comment>
-- 
To unsubscribe send an email with subject '<dtml-var unsubscribe>' to <dtml-var mailto>.
Please contact <dtml-var "moderator[0]"> for questions.
<dtml-var absolute_url>
"""

MailBoxerTemplates['mail_handler'] = r"""
<dtml-call "manage_listboxer(REQUEST)">

<dtml-comment>
 You can hook into this method for custom-workflows.
</dtml-comment>
"""

MailBoxerTemplates['mail_subscribe'] = r"""
<dtml-comment> 
 ** This scripts handles the subscribe-request **
</dtml-comment>

<dtml-if "mime_decode_header(mail['subject']).find(pin(mail['from']))==-1">

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail['from']">
From: <dtml-var mailto>
Reply-To: <dtml-var mailto>
X-Mailer: <dtml-var xmailer>
Subject: <dtml-var subscribe> [<dtml-var "pin(mail['from'])">]

Hello <dtml-var "mail['from']">,

if you really want to subscribe to <dtml-var title>, 
simply reply this mail immediatly to complete your subscription.

Yours, <dtml-var "moderator[0]">
</dtml-sendmail>

<dtml-else>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail['from']">
From: <dtml-var mailto>
Reply-To: <dtml-var mailto>
X-Mailer: <dtml-var xmailer>
Subject: Welcome to [<dtml-var title>]

Hello <dtml-var "mail['from']">,

you are now subscribed to <dtml-var title>.

Send your mails to: <dtml-var mailto>

If you want to unsubscribe from <dtml-var title>,
send a mail with subject (not body!):

<dtml-var unsubscribe> 

to: <dtml-var mailto>

Yours, <dtml-var "moderator[0]">
</dtml-sendmail>

</dtml-if>
"""

MailBoxerTemplates['mail_unsubscribe'] = r"""
<dtml-comment>
 ** This scripts handles unsubscribe-requests **
</dtml-comment>

<dtml-if "mime_decode_header(mail['subject']).find(pin(mail['from']))==-1">

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail['from']">
From: <dtml-var mailto>
Reply-To: <dtml-var mailto>
X-Mailer: <dtml-var xmailer>
Subject: <dtml-var unsubscribe> [<dtml-var "pin(mail['from'])">]

Hello <dtml-var "mail['from']">,

if you really want to unsubscribe from <dtml-var title>, 
simply reply this mail immediatly to complete your unsubscription.

Yours, <dtml-var "moderator[0]">
</dtml-sendmail>

<dtml-else>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail['from']">
From: <dtml-var mailto>
Reply-To: <dtml-var mailto>
X-Mailer: <dtml-var xmailer>
Subject: Unsubscribed from [<dtml-var title>]

Now you are unsubscribed from <dtml-var title>.

Have fun!!!

Yours, <dtml-var "moderator[0]">
</dtml-sendmail>
</dtml-if>
"""

MailBoxerTemplates['mail_reply'] = r"""
<dtml-comment>
This scripts sends an 'error' reply to the sender.
</dtml-comment>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail['from']">
From: <dtml-var mailto>
Reply-To: <dtml-var mailto>
X-Mailer: <dtml-var xmailer>
Subject: [<dtml-var title>] Mail unprocessed

Your email with the subject

 <dtml-var "mail['subject']">

could not be processed for the address

 <dtml-var "parseaddr(mail['from'])[1]">

for the mailinglist

 <dtml-var title>.

Possible reason:

<dtml-if "parseaddr(mail['from'])[1].lower() in maillist">
 - You tried to subscribe with a already subscribed address.
<dtml-else>
 - You are not subscribed to this list with the above address.
</dtml-if>

Yours, <dtml-var "moderator[0]">
</dtml-sendmail>
"""

MailBoxerTemplates['mail_moderator'] = r"""
<dtml-comment>
 ** Send a moderation-request to the first moderator **
</dtml-comment>

<dtml-sendmail mailhost="MailHost">
<dtml-in "mail.keys()" prefix=loop>
<dtml-if "loop_item=='to'">To: <dtml-var "moderator[0]">
<dtml-elif "loop_item=='subject'">Subject: [PLEASE MODERATE] <dtml-var "mail['subject']">
<dtml-else><dtml-var loop_item>: <dtml-var "mail[loop_item]">
</dtml-if></dtml-in>

<dtml-var body>
</dtml-sendmail>

<dtml-comment>
 ** Inform the the sender of what's going on **
</dtml-comment>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail['from']">
From: <dtml-var mailto>
Reply-To: <dtml-var mailto>
Subject: [RECEIVED] <dtml-var "mail['subject']">

Your mail will be checked by a moderator of this list.

Yours, 

<dtml-var "moderator[0]">
</dtml-sendmail>
"""

MailBoxerTemplates['index_html'] = r"""
<dtml-if "this().aq_parent.hasProperty('mailDate')">
 <dtml-return "RESPONSE.redirect(this().aq_parent.absolute_url())">
</dtml-if>
 
<dtml-var standard_html_header>

<table>
<tr>
<td valign="top">

<p>
<small>
<dtml-in PARENTS reverse>
 <dtml-if title>
/ <a href="<dtml-var absolute_url>"><dtml-if "this().aq_explicit.hasProperty('mailSubject')"><dtml-var mailSubject><dtml-else><dtml-var title html_quote></dtml-if></a>
 </dtml-if title>
</dtml-in PARENTS>
</small>
</p>

<p>
<form action="mail_search">
<dtml-if "previousObject(this())">
[ <a href="<dtml-var "previousObject(this()).absolute_url()">">&lt;&lt;</a> ]
</dtml-if>

<dtml-if "nextObject(this())">
[ <a href="<dtml-var "nextObject(this()).absolute_url()">">&gt;&gt;</a> ]
</dtml-if>

<input type="text" name="query"> <input type="submit" value=" Search ">
</form>
</p>

<p>
<small>
<dtml-if "previousObject(this())">
[ <a href="<dtml-var
"previousObject(this()).absolute_url()">"><dtml-var
"at(previousObject(this()).title)" html_quote></a> ]
</dtml-if>

<dtml-if "nextObject(this())">
[ <a href="<dtml-var "nextObject(this()).absolute_url()">">
<dtml-var "at(nextObject(this()).title)" html_quote></a> ]
</dtml-if>
</small>
</p>

<dtml-if mailDate>

 <dtml-var mail_template>

 <dtml-in "objectValues('Folder')" sort=id>
  <dtml-var mail_template>
 </dtml-in>

<dtml-else>
<dtml-in "objectValues('Folder')" sort=id reverse>
<dtml-if sequence-start><ul></dtml-if>
<li>
<dtml-if mailDate>
<b><dtml-var "mailDate.ISO()"> <a href="<dtml-var absolute_url>#<dtml-var getId>"><dtml-var
mailSubject html_quote null="No subject"></a><dtml-if "not aq_parent.hasProperty('mailDate')"> /
<dtml-var "at(mailFrom)" html_quote></dtml-if></b>
<br><small><dtml-var "at(mailBody[:200])" html_quote>...</small><br><br>
<dtml-else>
<b><a href="&dtml-absolute_url;"><dtml-var "at(title)" html_quote></a></b>
</dtml-if mailDate>
</li>
<dtml-in "objectValues('Folder')" sort=id reverse>
<dtml-if sequence-start><ul></dtml-if>
<li>
<dtml-if mailDate>
<dtml-if "not aq_parent.hasProperty('mailDate')"><dtml-var
"mailDate.Date()"><dtml-else><dtml-var "mailDate.ISO()"></dtml-if> <a href="<dtml-var absolute_url>#<dtml-var getId>"><dtml-if
"aq_parent.hasProperty('mailDate')"><dtml-var "at(mailFrom)"
html_quote null="No sender"><dtml-else><dtml-var mailSubject html_quote null="No subject"></dtml-if></a>
<dtml-let follow="_.len(objectIds(['Folder']))">
<dtml-if follow> [<dtml-var follow>]</dtml-if>
</dtml-let>
<dtml-else>
<a href="&dtml-absolute_url;"><dtml-var "at(title)" html_quote></a>
</dtml-if mailDate>
</li>
<dtml-if sequence-end></ul><br></dtml-if>
</dtml-in>
<dtml-if sequence-end></ul><br></dtml-if>
</dtml-in>

</dtml-if>
</td>

<dtml-if "meta_type=='Mail Boxer'">
<td valign="top">
<h3> Recent Posts </h3>

<dtml-in "_.getattr(this(),catalog).searchResults(mailDate={'query':_.DateTime()-7,'range':'min'},sort_on='mailDate')"
size=10 reverse>
<dtml-if sequence-start><ul></dtml-if sequence-start>
<dtml-with "_.getattr(this(),catalog).getobject(data_record_id_)">
<li><b><dtml-var "mailDate.ISO()"></b>
<a href="<dtml-var absolute_url>#<dtml-var getId>"><b><dtml-var mailSubject
null="No subject" html_quote></b></a> / <dtml-var "at(mailFrom)" html_quote>
<br><small><dtml-var "at(mailBody[:200])" html_quote></small><br><br></li>
</dtml-with>
<dtml-if sequence-end></ul></dtml-if>
<dtml-else>
Sorry, but there are no recent posts...
</dtml-in>
</td>
</dtml-if>

</tr>
</table>
<dtml-var standard_html_footer>
"""

MailBoxerTemplates['mail_template'] = r"""
<dtml-comment> This is the template for rendering a mail </dtml-comment>

<a name="<dtml-var getId>">

 <table width="100%" bgcolor="#e0e0e0">
 <tr>
  <td valign="top" width="60%"><b><dtml-var mailSubject html_quote></b>
     <br><dtml-var "at(mailFrom)" html_quote></td>
  <td valign="top" width="20%"><b><dtml-var "mailDate.ISO()"></b></td>
  <td valign="top" width="20%" align="right">

   <dtml-if fullMode>
   [ <a href="<dtml-var URL>#<dtml-var getId>">SNIP</a> ]
  <dtml-else>
   [ <a href="<dtml-var URL>?fullMode=1#<dtml-var getId>">FULL</a> ]
  </dtml-if> 
  </td> 
 </tr>
 </table>

</a>

 <table width="100%">
 <tr>
  <td>
   <dtml-if fullMode>
    <pre><dtml-var "textwrap(at(mailBody),79)" html_quote></pre>
   <dtml-else>
    <pre><dtml-var "textwrap(snipMail(at(mailBody)),79)"></pre>
   </dtml-if>
  </td>
 </tr>
  
 <dtml-if "objectValues('File')">
  <tr>
   <td>
   <table>
    <tr>
      <td><b>Attachments:</b></td><td>&nbsp;</td><td>&nbsp;</td>
    </tr>
    
    <dtml-in "objectValues('File')">
     <tr>
      <td><a href="<dtml-var absolute_url>/download"><dtml-var title></a></td>
      <td><dtml-var content_type></td>
      <td><dtml-var size> Bytes</td>
     </tr>
    </dtml-in>
   </table>
   </td>
  </tr>
 </dtml-if>
 </table>

<hr noshade>
"""

MailBoxerTemplates['mail_search'] = r"""<dtml-var standard_html_header>

<p><small>
<dtml-in PARENTS reverse>
<dtml-if title>
/ <a href="<dtml-var absolute_url>"><dtml-if "this().aq_explicit.hasProperty('mailSubject')"><dtml-var mailSubject null="No subject"><dtml-else><dtml-var title html_quote></dtml-if></a>
</dtml-if title>
</dtml-in PARENTS>
</small></p>

<form action="<dtml-var URL>" method="get">
Search: <input name="query" width=30 value="<dtml-var query missing>">
<input type="SUBMIT" name="SUBMIT" value=" Search ">
</form>

<dtml-if query>

<dtml-let recordList="[]">
<dtml-in "_.getattr(this(),catalog).searchResults(mailFrom=query)+
 	   _.getattr(this(),catalog).searchResults(mailSubject=query)+
	   _.getattr(this(),catalog).searchResults(mailBody=query)">
<dtml-if "data_record_id_ not in recordList"><dtml-call "recordList.append(data_record_id_)"></dtml-if>
</dtml-in>

<dtml-in recordList size=10 start=query_start>
 <dtml-if sequence-start>
   <dtml-if previous-sequence-start-number>

   <a href="<dtml-var
   URL><dtml-var sequence-query>query_start=<dtml-var
   previous-sequence-start-number>"><b>[
   &lt;&lt;&lt; ]</b></a>
   </dtml-if previous-sequence-start-number>

   &nbsp;<b><dtml-var sequence-length> hits</b>&nbsp;

   <dtml-if next-sequence-start-number>
   <a href="<dtml-var
   URL><dtml-var sequence-query>query_start=<dtml-var
   next-sequence-start-number>"><b>[ &gt;&gt;&gt;
   ]</b></a>
   </dtml-if next-sequence-start-number>
   
   <table width="100%" cellspacing="0" cellpadding="4">
   <tr>
   <th>Nr.</th><th>Date</th><th>Subject</th><th>From</th>
   </tr>
 </dtml-if sequence-start>

<dtml-with "_.getattr(this(),catalog).getobject(_['sequence-item'])">
<dtml-if sequence-even><tr bgcolor="#e0e0e0"><dtml-else><tr></dtml-if>
<td><dtml-var sequence-number></td>
<td><dtml-var "mailDate.ISO()"></td>
<td><a href="<dtml-var absolute_url>#<dtml-var getId>"><b><dtml-var mailSubject
null="No subject" html_quote></b></a>
<br><small><dtml-var "at(mailBody[:200])" html_quote></small></td>
<td><dtml-var "at(mailFrom)" html_quote></td>
</tr>
</dtml-with>

<dtml-if sequence-end></table></dtml-if>
 <dtml-else>
   There was no data matching this query.
</dtml-in recordList>
 </dtml-let recordList>
</dtml-if query>

<dtml-var standard_html_footer>
"""

MailBoxerTemplates['download'] = r"""Content-Type: <dtml-var content_type>
Content-Disposition: Attachment; Filename=<dtml-var title>

<dtml-var this>"""
