#!/usr/bin/env python

"""
 smtp2zope.py - Read a email from stdin and forward it to a url
 
 Usage: smtp2zope.py URL [maxBytes]
 
 URL      = call this URL with the email as a post-request
 maxBytes = optional: only forward mails < maxBytes to URL
"""

import sys, os, urllib

EXIT_USAGE = 64
EXIT_NOPERM = 77
EXIT_TEMPFAIL = 75

# Check if we have at least one parameter
if len(sys.argv) == 1:
    sys.exit(EXIT_USAGE)
    
# Get the url to call
callURL   = sys.argv[1]

# Check for optional maxBytes
if len(sys.argv) == 3:
    maxBytes  = long(sys.argv[2])
else:
    maxBytes  = 0 # means: unlimited!!!

# Get the raw mail and check its size
Mail = sys.stdin.read()

if maxBytes>0 and len(Mail)>maxBytes:
    sys.exit(EXIT_NOPERM)

try:
    urllib.urlopen(callURL,data='Mail='+urllib.quote(Mail))
except:
    # Server is probably down or something is misconfigured.
    # EXIT_TEMPFAIL causes the MTA to retry later on.
    sys.exit(EXIT_TEMPFAIL)
